## APMonitor Challenge Problem ##
## Solution by Trent Okeson    ##

from apm import *
import matplotlib.pyplot as plt
import numpy as np

s = 'http://byu.apmonitor.com'
a = 'parametric_study'

apm(s, a, 'clear all')
apm_load(s, a, 'model.apm')
csv_load(s, a, 'data.csv')

apm_option(s, a, 'nlc.imode', 6)
apm_option(s, a, 'nlc.nodes', 4)
apm_option(s, a, 'nlc.solver', 3)
apm_option(s, a, 'nlc.time_shift', 0)

apm_info(s, a, 'MV', 'u')
apm_info(s, a, 'FV', 'ts')
apm_option(s, a, 'u.status', 1)
apm_option(s, a, 'ts.status', 1)
apm_info(s, a, 'FV', 'xend')

xend = np.linspace(1,10,10)

for i in xend:
    apm_meas(s,a,'xend',i)
    output = apm(s, a, 'solve')
    print output
    y = apm_sol(s, a)

    # create a time vector scaled by tf
    ts = y['ts'][0]
    time = np.zeros(len(y['time']))
    yn = np.zeros(len(y['y']))
    for i in range(len(time)):
        time[i] = y['time'][i] * ts
        yn[i] = -y['y'][i]

    plt.figure(1)
    plt.plot(y['x'], yn,linewidth=2)

plt.xlabel('Position (x)')
plt.ylabel('Position (-y)')
plt.axis([0,10,-4,0])
plt.savefig('results.png')

plt.show()
